local open = assert(loadlib("./rlcompleter.so", "luaopen_rlcompleter"))
--local open = assert(loadlib("/home/nop/lua-completer/rlcompleter.so", "luaopen_rlcompleter"))
open()

local function safecompleter(s, state)
  if not rlcompleter.complete then
    return nil
  end

  local function wrapped() 
    return rlcompleter.complete(s, state) 
  end

  local worked, rv = xpcall(wrapped, debug.traceback)
  if worked then
    return rv
  else
    print()
    print(rv)
    rlcompleter.redisplay()
    return nil
  end  
end
    
rlcompleter._set(safecompleter)

local function tablematches(t, str, prefix)
  if type(t) ~= "table" then return {} end
  prefix = prefix or ""
  str = "^"..str
  local matches = {n=0}
  for k,v in pairs(t) do 
    if type(k) == "string" and string.find(k, str) then
      local expand = prefix..k
      if type(v) == "table" then
        expand = expand.."."
      end
      table.insert(matches, expand)
    end
  end
  table.sort(matches)
  return matches
end

rlcompleter.tablematches = tablematches

-- returns a table, the prefix inside the table, and the string path used to get to the table
local function findtable(s)
  local t = _G
  local leading = ""
  for w, d in string.gfind(s, "([%w_]+)(.?)") do
    if d == "." then
      t = t[w]
      leading = leading..w.."."
      -- if type(t) ~= "table" then 
      if not t then 
        return {}, "", leading
      end
    else
      return t, w, leading
    end
  end
  return t, "", leading
end

rlcompleter.findtable = findtable

local savematch
local function default(s, state)
  if state == 0 then
    local t,prefix,leading = findtable(s)
    savematch = tablematches(t, prefix, leading)
    return savematch[1]
  else
    return savematch[state+1]
  end
end

rlcompleter.default = default
rlcompleter.complete = default

return rlcompleter
